#region  Name Space Imports
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using System.Collections;
using System.IO;
using Syncfusion.Windows.Forms.Tools.MultiColumnTreeView;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Tools.XPMenus;
#endregion

namespace MultiColumnTreeViewDemo
{
	public partial class MainForm : MetroForm
	{
		#region Declarations
			private Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv treeColumnAdv1;
			private Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv treeColumnAdv2;
			private Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv treeColumnAdv3;
		#endregion

		#region Constructor
			public MainForm()
			{
				InitializeComponent();

				treeColumnAdv1 = new Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv();
				treeColumnAdv2 = new Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv();
				treeColumnAdv3 = new Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv();

				treeColumnAdv1.HelpText = "Name";
				treeColumnAdv1.Highlighted = false;
				treeColumnAdv1.Text = "Name";
				treeColumnAdv1.Width = 320;
				treeColumnAdv1.Background = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.White, System.Drawing.Color.LightBlue);
				treeColumnAdv1.AreaBackground = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.ForwardDiagonal, System.Drawing.Color.White, System.Drawing.Color.LightBlue);
				treeColumnAdv1.BorderStyle = BorderStyle.FixedSingle;

				treeColumnAdv2.HelpText = "Full Path";
				treeColumnAdv2.Highlighted = false;
				treeColumnAdv2.Text = "Full Path";
				treeColumnAdv2.Width = 260;
				treeColumnAdv2.Background = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.White, System.Drawing.Color.LightBlue);
				treeColumnAdv2.BorderStyle = BorderStyle.FixedSingle;

				treeColumnAdv3.HelpText = "Parent Name";
				treeColumnAdv3.Highlighted = false;
				treeColumnAdv3.Text = "Parent Name";
				treeColumnAdv3.Width = 150;
				treeColumnAdv3.Background = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.White, System.Drawing.Color.LightBlue);
				treeColumnAdv3.BorderStyle = BorderStyle.FixedSingle;

				this.multiColumnTreeView1.Columns.AddRange(new Syncfusion.Windows.Forms.Tools.MultiColumnTreeView.TreeColumnAdv[] {treeColumnAdv1, treeColumnAdv2, treeColumnAdv3});

				Load += new System.EventHandler(MultiColumnTreeViewDemo_Load);
			}
		#endregion

		#region MultiColumnTreeView Event Handlers
			private void MultiColumnTreeViewDemo_Load(object sender, EventArgs e)
			{
				TreeNodeAdv root1 = null;
				TreeNodeAdv root2 = null;
				TreeNodeAdv root3 = null;
				TreeNodeAdv root4 = null;
				TreeNodeAdv child = null;

				root1 = new TreeNodeAdv("Root 1");
				root2 = new TreeNodeAdv("Root 2");
				root3 = new TreeNodeAdv("Root 3");
				root4 = new TreeNodeAdv("Root 4");

				this.multiColumnTreeView1.Nodes.AddRange(new TreeNodeAdv[]{root1,root2,root3,root4});
				int i =5;
				foreach (TreeNodeAdv root in this.multiColumnTreeView1.Nodes)
				{
					root.SubItems.AddRange(new TreeNodeAdvSubItem[] { new TreeNodeAdvSubItem(""), new TreeNodeAdvSubItem("") });
					i =5;
					while (i >= 0)
					{
						child = new TreeNodeAdv("Child " + i);
						child.SubItems.AddRange(new TreeNodeAdvSubItem[] { new TreeNodeAdvSubItem("Sub " + i), new TreeNodeAdvSubItem("Sub " + (9- i)) });
						root.Nodes.Add(child);
						i -= 1;
					}
				}

				this.multiColumnTreeView1.ExpandAll();
			}
		#endregion

		#region Color Picker Event Handler
			private void colorPickerButton3_ColorSelected(object sender, EventArgs e)
			{
			}

			private void colorPickerButton2_ColorSelected(object sender, EventArgs e)
			{
			}

			private void colorPickerButton1_ColorSelected(object sender, EventArgs e)
			{
			}
		#endregion

		#region SortImplementation

            //To Sort the MultiColumnTreeView based on the Column index
			private void SortNodesByColumn(TreeNodeAdv ParentNode, int ColumnIndex)
			{
				foreach (TreeNodeAdv node in ParentNode.Nodes)
				{
					if (node.HasNodes)
					{
						SortNodesByColumn(node, 1);
					}
					node.Nodes.Sort(new SortBySubItems(this.multiColumnTreeView1, ColumnIndex, this.CheckBox1.Checked));
				}

			}

		#endregion

		#region Menu Item Click Handlers
			private void sToolStripMenuItem_Click(object sender, EventArgs e)
			{
				if (this.CheckBox1.Checked)
				{
					this.multiColumnTreeView1.Nodes.Sort(SortOrder.Ascending);
				}
				else
				{
					this.multiColumnTreeView1.Nodes.Sort(SortOrder.Descending);
				}
			}

			private void sortByColumn2ToolStripMenuItem_Click(object sender, EventArgs e)
			{
                //Pass the columnindex and root of the MultiColumnTreeView
				SortNodesByColumn(this.multiColumnTreeView1.Root, 1);
			}

			private void SortByColumn2ToolStripMenuItem1_Click(object sender, System.EventArgs e)
			{
				SortNodesByColumn(this.multiColumnTreeView1.Root, 2);
			}
		#endregion

	}
		#region IComparer Implemenation

			public class SortBySubItems : IComparer
			{
				private MultiColumnTreeView tree;
				private int columnIndex;
				private bool Ascending;


				public SortBySubItems(MultiColumnTreeView tree, int columnIndex, bool Ascending)
				{
					// Holds a reference to the Tree and ColumnIndex for sorting
					this.tree = tree;
					this.columnIndex = columnIndex;
					this.Ascending = Ascending;
				}

				public int Compare(object x, object y)
				{
					TreeNodeAdv _nodeX = x as TreeNodeAdv;
					TreeNodeAdv _nodeY = y as TreeNodeAdv;

					if (Ascending)
					{
						return _nodeX.SubItems[columnIndex].Text.CompareTo(_nodeY.SubItems[columnIndex].Text);
					}
					else
					{
						return _nodeY.SubItems[columnIndex].Text.CompareTo(_nodeX.SubItems[columnIndex].Text);
					}

				}
			}
		#endregion
}